#include "StdAfx.h"
#include "WebApp.h"
#include "Base.h"

CBase::CBase(Wt::WContainerWidget* pParent) 
: 
    WTemplate(pParent)
{
    addFunction("tr", &Wt::WTemplate::Functions::tr);
    
    setAttributeValue("alt", "BaseWidget");
    
    pLang_ = new Wt::WComboBox();
    pLang_->addStyleClass("myclass");
    pLang_->addItem("it");
    pLang_->addItem("en");
    bindWidget("langs", pLang_);

    pLang_->changed().connect(this, &CBase::OnLangChanged);
}

CBase::~CBase(void)
{
}

void CBase::refresh()
{
    WTemplate::refresh();
    
    doJavaScript("m_init();");
}

void CBase::OnLangChanged()
{
    CWebApp* pApp = dynamic_cast<CWebApp*>(Wt::WApplication::instance());

    if (pApp)
    {
        int idx = pLang_->currentIndex();
        Wt::WString str = pLang_->itemText(idx);
        pApp->setLocale(str.toUTF8());
    }
}