// WT6637.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "conio.h"

#include <list>
//#include <boost/foreach.hpp>

#include "WebApp.h"

#ifndef WITH_WT321
//#define WAIT_A_LITTLE
#endif

Wt::WServer server;

//for posting
//std::list<std::string> sessIds;
std::string sessId;

Wt::WApplication* createApp(const Wt::WEnvironment& env)
{
    CWebApp* pApp = new CWebApp(env);
    //sessIds.push_back(pApp->sessionId());
    //std::cout << std::endl << "New session. Sess list size: " << sessIds.size() << std::endl << std::endl;
    sessId = pApp->sessionId();
    return pApp;
}


bool stop();
void showEndPage(bool lock=true)
{
    CWebApp* pApp = dynamic_cast<CWebApp*>(Wt::WApplication::instance());
    //Sleep(1000);
    pApp->End();
}

bool end()
{
    std::cout << "Ending transmission ..." << std::endl;

    //std::cout << std::endl << "Posting show end page. Sess list size: " << sessIds.size() << std::endl << std::endl;
    std::cout << "Posting show end page. " << std::endl;
    
    //BOOST_FOREACH(std::string sessId, sessIds)
    {
        server.post(sessId, boost::bind(showEndPage, false));
    }

    //cleanup the session list becuase anyway the server will stop
    //sessIds.clear();

#ifdef WAIT_A_LITTLE
    Sleep(10);
#endif

    return stop();
}

bool isRunning()
{
    return server.isRunning();
}

bool start(int argc, char* argv[])
{
    if (!argc)
        return false;
    if (isRunning())
        return false;

    try 
    {
        std::cout << "Starting server ..." << std::endl;
        
        server.setServerConfiguration(argc, argv, WTHTTP_CONFIGURATION);

        server.addEntryPoint(Wt::Application, createApp);
        
        return server.start();

    } 
    catch (Wt::WServer::Exception& e) 
    {
        std::cerr << e.what() << "\n";
        return false;
    } 
    catch (std::exception& e) 
    {
        std::cerr << "exception: " << e.what() << "\n";
        return false;
    }
}

bool stop()
{
    try 
    {
        if (isRunning())
        {
            //std::cout << "stopping server ..." << std::endl;
            server.stop();
            return !isRunning();
        }
        else
            return false;
    } 
    catch (Wt::WServer::Exception& e) 
    {
        std::cerr << e.what() << "\n";
        return false;
    } 
    catch (std::exception& e) 
    {
        std::cerr << "exception: " << e.what() << "\n";
        return false;
    }
}

void quit()
{
    if (isRunning())
        stop();
}

int main(int argc, char* argv[])
{
    start(argc, argv);
    
    int ch;
    while ((ch = _getch()))
    {
        switch(ch)
        {
            case 's':
                if (start(argc, argv))
                    std::cout << "server started" << std::endl;
                break;
            case 't':
                //if (stop())
                if (isRunning() && end())
                    std::cout << "server stopped" << std::endl;
                break;
            case 'q':
            case 0x1b:
                quit();
                return 0;
        }
    }
	return 0;
}
